## org.apache.catalina
Interface Manager

All Known Implementing Classes:
  ManagerBase

public interface Manager

A Manager manages the pool of Sessions that are associated with a particular Container. Different Manager implementations may support value-added features such as the persistent storage of session data, as well as migrating sessions for distributable web applications.

In order for a `Manager` implementation to successfully operate with a `Context` implementation that implements reloading, it must obey the following constraints:

- Must implement `Lifecycle` so that the Context can indicate that a restart is required.
- Must allow a call to `stop()` to be followed by a call to `start()` on the same `Manager` instance.

Version:
  $Revision: 1.10 $ $Date: 2004/08/26 22:05:53 $
Author:
  Craig R. McClanahan

Method Summary
`void` `add(Session session)` Add this Session to the set of active Sessions for this Manager.
`void` `addPropertyChangeListener(java.beans.PropertyChangeListener listener)` Add a property change listener to this component.
`Session` `createEmptySession()` Get a session from the recycled ones or create a new empty one.
`Session` `createSession()` Construct and return a new session object, based on the default settings specified by this Manager's properties.
`Session` `findSession(java.lang.String id)` Return the active Session, associated with this Manager, with the specified session id (if any); otherwise return `null`.
`Session[]` `findSessions()` Return the set of active Sessions associated with this Manager.
`Container` `getContainer()` Return the Container with which this Manager is associated.
`DefaultContext` `getDefaultContext()` Return the DefaultContext with which this Manager is associated.
`boolean` `getDistributable()` Return the distributable flag for the sessions supported by this Manager.
`java.lang.String` `getInfo()` Return descriptive information about this Manager implementation and the corresponding version number, in the format `<description>/<version>`.
`int` `getMaxInactiveInterval()` Return the default maximum inactive interval (in seconds) for Sessions created by this Manager.
`void` `load()` Load any currently active sessions that were previously unloaded to the appropriate persistence mechanism, if any.
`void` `remove(Session session)` Remove this Session from the active Sessions for this Manager.
`void` `removePropertyChangeListener(java.beans.PropertyChangeListener listener)` Remove a property change listener from this component.
`void` `setContainer(Container container)` Set the Container with which this Manager is associated.
`void` `setDefaultContext(DefaultContext defaultContext)` Set the DefaultContext with which this Manager is associated.
`void` `setDistributable(boolean distributable)` Set the distributable flag for the sessions supported by this Manager.
`void` `setMaxInactiveInterval(int interval)` Set the default maximum inactive interval (in seconds) for Sessions created by this Manager.
`void` `unload()` Save any currently active sessions in the appropriate persistence mechanism, if any.

Method Detail

### getContainer

    public Container getContainer()

  Return the Container with which this Manager is associated.

### setContainer

    public void setContainer(Container container)

  Set the Container with which this Manager is associated.

  Parameters:
    `container` - The newly associated Container

### getDefaultContext

    public DefaultContext getDefaultContext()

  Return the DefaultContext with which this Manager is associated.

### setDefaultContext

    public void setDefaultContext(DefaultContext defaultContext)

  Set the DefaultContext with which this Manager is associated.

  Parameters:
    `defaultContext` - The newly associated DefaultContext

### getDistributable

    public boolean getDistributable()

  Return the distributable flag for the sessions supported by this Manager.

### setDistributable

    public void setDistributable(boolean distributable)

  Set the distributable flag for the sessions supported by this Manager. If this flag is set, all user data objects added to sessions associated with this manager must implement Serializable.

  Parameters:
    `distributable` - The new distributable flag

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this Manager implementation and the corresponding version number, in the format `<description>/<version>`.

### getMaxInactiveInterval

    public int getMaxInactiveInterval()

  Return the default maximum inactive interval (in seconds) for Sessions created by this Manager.

### setMaxInactiveInterval

    public void setMaxInactiveInterval(int interval)

  Set the default maximum inactive interval (in seconds) for Sessions created by this Manager.

  Parameters:
    `interval` - The new default value

### add

    public void add(Session session)

  Add this Session to the set of active Sessions for this Manager.

  Parameters:
    `session` - Session to be added

### createEmptySession

    public Session createEmptySession()

  Get a session from the recycled ones or create a new empty one. The PersistentManager manager does not need to create session data because it reads it from the Store.

### addPropertyChangeListener

    public void addPropertyChangeListener(java.beans.PropertyChangeListener listener)

  Add a property change listener to this component.

  Parameters:
    `listener` - The listener to add

### createSession

    public Session createSession()

  Construct and return a new session object, based on the default settings specified by this Manager's properties. The session id will be assigned by this method, and available via the getId() method of the returned session. If a new session cannot be created for any reason, return `null`.

  Throws:
    `java.lang.IllegalStateException` - if a new session cannot be instantiated for any reason

### findSession

    public Session findSession(java.lang.String id)
                        throws java.io.IOException

  Return the active Session, associated with this Manager, with the specified session id (if any); otherwise return `null`.

  Parameters:
    `id` - The session id for the session to be returned
  Throws:
    `java.lang.IllegalStateException` - if a new session cannot be instantiated for any reason
    `java.io.IOException` - if an input/output error occurs while processing this request

### findSessions

    public Session[] findSessions()

  Return the set of active Sessions associated with this Manager. If this Manager has no active Sessions, a zero-length array is returned.

### load

    public void load()
              throws java.lang.ClassNotFoundException,
                     java.io.IOException

  Load any currently active sessions that were previously unloaded to the appropriate persistence mechanism, if any. If persistence is not supported, this method returns without doing anything.

  Throws:
    `java.lang.ClassNotFoundException` - if a serialized class cannot be found during the reload
    `java.io.IOException` - if an input/output error occurs

### remove

    public void remove(Session session)

  Remove this Session from the active Sessions for this Manager.

  Parameters:
    `session` - Session to be removed

### removePropertyChangeListener

    public void removePropertyChangeListener(java.beans.PropertyChangeListener listener)

  Remove a property change listener from this component.

  Parameters:
    `listener` - The listener to remove

### unload

    public void unload()
                throws java.io.IOException

  Save any currently active sessions in the appropriate persistence mechanism, if any. If persistence is not supported, this method returns without doing anything.

  Throws:
    `java.io.IOException` - if an input/output error occurs

Copyright ? 2000-2002 Apache Software Foundation. All Rights Reserved.